Freedom Trail(leetcode)

来源:互联网 发布:网络大电影排名 编辑:程序博客网 时间:2024/05/19 02:40

Freedom Trail

        In the video game Fallout 4, the quest "Road to Freedom" requires players to reach a metal dial called the "Freedom Trail Ring", and use the dial to spell a specific keyword in order to open the door.

        Given a string ring, which represents the code engraved on the outer ring and another string key, which represents the keyword needs to be spelled. You need to find the minimum number of steps in order to spell all the characters in the keyword.

        Initially, the first character of the ring is aligned at 12:00 direction. You need to spell all the characters in the string key one by one by rotating the ring clockwise or anticlockwise to make each character of the string key aligned at 12:00 direction and then by pressing the center button. 
At the stage of rotating the ring to spell the key character key[i]:
  1. You can rotate the ring clockwise or anticlockwise one place, which counts as 1 step. The final purpose of the rotation is to align one of the string ring's characters at the 12:00 direction, where this character must equal to the character key[i].
  2. If the character key[i] has been aligned at the 12:00 direction, you need to press the center button to spell, which also counts as 1 step. After the pressing, you could begin to spell the next character in the key (next stage), otherwise, you've finished all the spelling.

Example:


Input: ring = "godding", key = "gd"Output: 4Explanation:
For the first key character 'g', since it is already in place, we just need 1 step to spell this character.
For the second key character 'd', we need to rotate the ring "godding" anticlockwise by two steps to make it become "ddinggo".
Also, we need 1 more step for spelling.
So the final output is 4.

Note:

  1. Length of both ring and key will be in range 1 to 100.
  2. There are only lowercase letters in both strings and might be some duplcate characters in both strings.
  3. It's guaranteed that string key could always be spelled by rotating the string ring.

        虽然题目是被归为分治算法的范围,但用动态规划来做也是可以。本人想出的动态规划算法时间复杂度是O(n3),空间复杂度是O(n2)。说实话有点慢,19ms......

解题思路:

        动态规划。用二位数组v[i][j]存储步数(先不考虑按下按钮的步数)。i表示key的第i个字符;j表示key[i]所对应的ring的下标(即key[i] == ring[j]);v[i][j]表示从开始到key[i]所对应的环上的字符ring[j]被选中时总共旋转的步数。所以

v[i][j] = min(v[i-1][k]+dis(k, j))      (key[i-1] == ring[k])

        dis(k, j)表示ring上下标k到j的较短旋转距离(即步数)。

代码:

class Solution {public:    int getdis(int begin, int end, int len) {        int n = abs(end-begin);        return (n < len-n) ? n : len-n;    }    int findRotateSteps(string ring, string key) {    vector<vector<int> > v(100, vector<int>(100, INT_MAX));        if(ring.length() <= 0 || key.length() <= 0) return 0;        int i, j, k;        int kl = key.length(), rl = ring.length();        int result = INT_MAX;        for (i = 0; i < kl; ++i) {            for (j = 0; j < rl; ++j) {                if (i == 0) {                    if (ring[j] == key[i]) {                        v[0][j] = getdis(0, j, rl);                    }                    continue;                }                if (ring[j] == key[i-1]) {                    for (k = 0; k < rl; ++k) {                        if (ring[k] == key[i]) {                            v[i][k] = min(v[i][k], getdis(j, k, rl) + v[i-1][j]);                        }                        if (i == kl-1) {                        result = min(result, v[i][k]);}                     }                }            }        }        return result + kl;    }};


原创粉丝点击